function [ MC_output ] = compute_ospa_linGauss( MC_input, truth, MC )
%[ MC_output ] = compute_ospa_linGauss( MC_input, truth, MC )


ospa_dim = 2;

MC_output = MC_input; 

model = MC_input.model;

for nb_sensor_index = 1:size(MC_input,1)
    for pd_index = 1:size(MC_input,2)
        
        ic_cbmember = MC_input(nb_sensor_index, pd_index).ic_cbmember;
        member      = MC_input(nb_sensor_index, pd_index).ms_member;
        cphd        = MC_input(nb_sensor_index, pd_index).ms_cphd;
        tcphd       = MC_input(nb_sensor_index, pd_index).ms_tcphd;
        
        
        ic_cbmember_ospa       = zeros(MC, truth.K);
        ic_cbmember_ospa_card  = zeros(MC, truth.K);
        ic_cbmember_ospa_track = zeros(MC, truth.K);
        
        member_ospa       = zeros(MC, truth.K);
        member_ospa_card  = zeros(MC, truth.K);
        member_ospa_track = zeros(MC, truth.K);
        
        cphd_ospa       = zeros(MC, truth.K);
        cphd_ospa_card  = zeros(MC, truth.K);
        cphd_ospa_track = zeros(MC, truth.K);
        
        tcphd_ospa       = zeros(MC, truth.K);
        tcphd_ospa_card  = zeros(MC, truth.K);
        tcphd_ospa_track = zeros(MC, truth.K);
        
        for mc = 1:MC
            
            for t = 1:truth.K
                
                truth_xy = [];        if size(truth.X{t},2), truth_xy = truth.X{t}(1:ospa_dim,:); end
                ic_cbmember_xy = [];  if size(ic_cbmember.x_est{mc}{t},2), ic_cbmember_xy = ic_cbmember.x_est{mc}{t}(1:ospa_dim,:); end
                member_xy = [];       if size(member.x_est{mc}{t},2), member_xy = member.x_est{mc}{t}(1:ospa_dim,:); end
                cphd_xy = [];         if size(cphd.x_est{mc}{t},2), cphd_xy = cphd.x_est{mc}{t}(1:ospa_dim,:); end
                tcphd_xy = [];        if size(tcphd.x_est{mc}{t},2), tcphd_xy = tcphd.x_est{mc}{t}(1:ospa_dim,:); end
                
                [ic_cbmember_ospa(mc,t), ic_cbmember_ospa_track(mc,t), ic_cbmember_ospa_card(mc,t)] = ospa_dist( truth_xy, ic_cbmember_xy, model.ospa_cutoff, model.ospa_order);
                [member_ospa(mc,t), member_ospa_track(mc,t), member_ospa_card(mc,t)] = ospa_dist( truth_xy, member_xy, model.ospa_cutoff, model.ospa_order);
                [cphd_ospa(mc,t),   cphd_ospa_track(mc,t),   cphd_ospa_card(mc,t)] = ospa_dist( truth_xy, cphd_xy, model.ospa_cutoff, model.ospa_order);
                [tcphd_ospa(mc,t),  tcphd_ospa_track(mc,t),  tcphd_ospa_card(mc,t)] = ospa_dist( truth_xy, tcphd_xy, model.ospa_cutoff, model.ospa_order);
                
            end
        end
        
        MC_output(nb_sensor_index, pd_index).ic_cbmember.ospa = ic_cbmember_ospa;
        MC_output(nb_sensor_index, pd_index).ms_member.ospa   = member_ospa;
        MC_output(nb_sensor_index, pd_index).ms_cphd.ospa     = cphd_ospa;
        MC_output(nb_sensor_index, pd_index).ms_tcphd.ospa    = tcphd_ospa;
    end
end

end

