function [ MC_output ] = compute_ospa_nonLin( MC_input, truth, MC )
%[ MC_output ] = compute_ospa_nonLin( MC_input, truth, MC )

MC_output = MC_input;

model = MC_input.model;

dim_ospa = 4;

for i = 1:numel(MC_input)
for mc = 1:MC
   
    for t = 1:truth.K
       
        X_truth = [];   
        if ~isempty(truth.X{t})
            X_truth = truth.X{t}(1:dim_ospa,:);
        end
        
        X_est=[];  % cphd ukf  
        if ~isempty(MC_input(i).ms_cphd_ukf.x_est{mc}{t})
           X_est =  MC_input(i).ms_cphd_ukf.x_est{mc}{t}(1:dim_ospa,:);
        end
        
        MC_output(i).ms_cphd_ukf.ospa(mc,t) = ospa_dist( X_truth, X_est, model.ospa_cutoff, model.ospa_order);
        
        

        X_est=[];  % cphd smc  
        if ~isempty(MC_input(i).ms_cphd_smc.x_est{mc}{t})
           X_est =  MC_input(i).ms_cphd_smc.x_est{mc}{t}(1:dim_ospa,:);
        end
        
        MC_output(i).ms_cphd_smc.ospa(mc,t) = ospa_dist( X_truth, X_est, model.ospa_cutoff, model.ospa_order);
                
        
        X_est=[];  % tcphd ukf  
        if ~isempty(MC_input(i).ms_tcphd_ukf.x_est{mc}{t})
           X_est =  MC_input(i).ms_tcphd_ukf.x_est{mc}{t}(1:dim_ospa,:);
        end
        
        MC_output(i).ms_tcphd_ukf.ospa(mc,t) = ospa_dist( X_truth, X_est, model.ospa_cutoff, model.ospa_order);
        
        

        X_est=[];  % tcphd smc  
        if ~isempty(MC_input(i).ms_tcphd_smc.x_est{mc}{t})
           X_est =  MC_input(i).ms_tcphd_smc.x_est{mc}{t}(1:dim_ospa,:);
        end
        
        MC_output(i).ms_tcphd_smc.ospa(mc,t) = ospa_dist( X_truth, X_est, model.ospa_cutoff, model.ospa_order);

        
          X_est=[];  % member ukf  
        if ~isempty(MC_input(i).ms_member_ukf.x_est{mc}{t})
           X_est =  MC_input(i).ms_member_ukf.x_est{mc}{t}(1:dim_ospa,:);
        end
        
        MC_output(i).ms_member_ukf.ospa(mc,t) = ospa_dist( X_truth, X_est, model.ospa_cutoff, model.ospa_order);
        
        

        X_est=[];  % member smc  
        if ~isempty(MC_input(i).ms_member_smc.x_est{mc}{t})
           X_est =  MC_input(i).ms_member_smc.x_est{mc}{t}(1:dim_ospa,:);
        end
        
        MC_output(i).ms_member_smc.ospa(mc,t) = ospa_dist( X_truth, X_est, model.ospa_cutoff, model.ospa_order);

        
       X_est=[];  % ic cbmember ukf  
        if ~isempty(MC_input(i).ic_cbmember_ukf.x_est{mc}{t})
           X_est =  MC_input(i).ic_cbmember_ukf.x_est{mc}{t}(1:dim_ospa,:);
        end
        
        MC_output(i).ic_cbmember_ukf.ospa(mc,t) = ospa_dist( X_truth, X_est, model.ospa_cutoff, model.ospa_order);
        
        

        X_est=[];  % ic cbmember smc  
        if ~isempty(MC_input(i).ic_cbmember_smc.x_est{mc}{t})
           X_est =  MC_input(i).ic_cbmember_smc.x_est{mc}{t}(1:dim_ospa,:);
        end
        
        MC_output(i).ic_cbmember_smc.ospa(mc,t) = ospa_dist( X_truth, X_est, model.ospa_cutoff, model.ospa_order);
             
    end
    
end

end


end

